#line 1 "ext/ohcount_native/ragel_parsers/java.rl"
// java.rl written by Mitchell Foral. mitchell<att>caladbolg<dott>net.

/************************* Required for every parser *************************/
#ifndef RAGEL_JAVA_PARSER
#define RAGEL_JAVA_PARSER

#include "ragel_parser_macros.h"

// the name of the language
const char *JAVA_LANG = "java";

// the languages entities
const char *java_entities[] = {
  "space", "comment", "string", "number",
  "keyword", "identifier", "operator", "any"
};

// constants associated with the entities
enum {
  JAVA_SPACE = 0, JAVA_COMMENT, JAVA_STRING, JAVA_NUMBER,
  JAVA_KEYWORD, JAVA_IDENTIFIER, JAVA_OPERATOR, JAVA_ANY
};

/*****************************************************************************/


#line 29 "ext/ohcount_native/ragel_parsers/java.h"
static const char _java_actions[] = {
	0, 1, 1, 1, 4, 1, 5, 1, 
	7, 1, 8, 1, 9, 1, 10, 1, 
	12, 1, 13, 1, 16, 1, 17, 1, 
	18, 1, 19, 1, 20, 1, 22, 1, 
	23, 1, 24, 1, 25, 1, 26, 2, 
	3, 2, 2, 5, 14, 2, 6, 15, 
	2, 8, 21, 2, 11, 6, 2, 11, 
	8, 3, 3, 2, 1, 3, 11, 0, 
	6
};

static const char _java_cond_offsets[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 2, 3, 3, 3, 3, 3, 3, 
	3, 4, 4, 4, 4, 4, 4
};

static const char _java_cond_lengths[] = {
	0, 0, 0, 0, 0, 0, 0, 1, 
	1, 1, 0, 0, 0, 0, 0, 0, 
	1, 0, 0, 0, 0, 0, 0
};

static const short _java_cond_keys[] = {
	13, 13, 13, 13, 13, 13, 13, 13, 
	0
};

static const char _java_cond_spaces[] = {
	0, 0, 0, 0, 0
};

static const char _java_key_offsets[] = {
	0, 0, 1, 3, 8, 11, 16, 19, 
	30, 41, 53, 54, 55, 59, 62, 64, 
	67, 80, 82, 87, 92, 94, 97
};

static const short _java_trans_keys[] = {
	42, 42, 47, 10, 34, 92, 12, 13, 
	10, 12, 13, 10, 39, 92, 12, 13, 
	10, 12, 13, 9, 10, 12, 32, 42, 
	269, 525, -128, 11, 14, 127, 9, 10, 
	12, 32, 42, 269, 525, -128, 11, 14, 
	127, 9, 10, 12, 32, 42, 47, 269, 
	525, -128, 11, 14, 127, 10, 10, 32, 
	47, 9, 13, 32, 9, 13, 42, 47, 
	10, 12, 13, 9, 10, 12, 32, 34, 
	39, 47, 269, 525, -128, 8, 14, 127, 
	9, 32, 10, 34, 92, 12, 13, 10, 
	39, 92, 12, 13, 42, 47, 10, 12, 
	13, 10, 0
};

static const char _java_single_lengths[] = {
	0, 1, 2, 3, 1, 3, 1, 7, 
	7, 8, 1, 1, 2, 1, 2, 1, 
	9, 2, 3, 3, 2, 1, 1
};

static const char _java_range_lengths[] = {
	0, 0, 0, 1, 1, 1, 1, 2, 
	2, 2, 0, 0, 1, 1, 0, 1, 
	2, 0, 1, 1, 0, 1, 0
};

static const char _java_index_offsets[] = {
	0, 0, 2, 5, 10, 13, 18, 21, 
	31, 41, 52, 54, 56, 60, 63, 66, 
	69, 81, 84, 89, 94, 97, 100
};

static const char _java_indicies[] = {
	2, 1, 2, 3, 1, 4, 6, 7, 
	4, 5, 4, 4, 5, 4, 6, 9, 
	4, 8, 4, 4, 8, 11, 12, 12, 
	11, 13, 14, 12, 10, 10, 4, 16, 
	17, 17, 16, 18, 19, 17, 15, 15, 
	4, 11, 12, 12, 11, 13, 20, 14, 
	12, 10, 10, 4, 12, 4, 21, 22, 
	24, 25, 24, 23, 24, 24, 26, 1, 
	28, 27, 29, 29, 28, 31, 21, 21, 
	31, 32, 33, 34, 35, 36, 30, 30, 
	22, 31, 31, 37, 38, 6, 7, 38, 
	5, 38, 6, 9, 38, 8, 10, 39, 
	38, 40, 40, 41, 21, 42, 0
};

static const char _java_trans_targs[] = {
	12, 1, 2, 12, 16, 3, 16, 4, 
	5, 6, 7, 7, 8, 9, 10, 7, 
	7, 8, 9, 10, 16, 16, 0, 12, 
	13, 14, 12, 12, 15, 12, 16, 17, 
	18, 19, 20, 11, 22, 16, 16, 21, 
	16, 21, 16
};

static const char _java_trans_actions[] = {
	37, 9, 9, 48, 27, 0, 17, 0, 
	0, 0, 1, 0, 0, 1, 0, 57, 
	39, 39, 57, 39, 15, 42, 0, 29, 
	7, 54, 31, 35, 9, 33, 45, 3, 
	61, 61, 51, 5, 5, 19, 25, 1, 
	21, 0, 23
};

static const char _java_to_state_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 11, 0, 0, 0, 
	11, 0, 0, 0, 0, 0, 0
};

static const char _java_from_state_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 13, 0, 0, 0, 
	13, 0, 0, 0, 0, 0, 0
};

static const char _java_eof_trans[] = {
	0, 1, 1, 5, 5, 5, 5, 5, 
	5, 5, 5, 0, 0, 27, 28, 30, 
	0, 38, 39, 39, 39, 41, 43
};

static const int java_start = 12;
static const int java_first_final = 12;
static const int java_error = 0;

static const int java_en_java_line = 16;
static const int java_en_java_entity = 12;

#line 88 "ext/ohcount_native/ragel_parsers/java.rl"


/************************* Required for every parser *************************/

/* Parses a string buffer with Java code.
 *
 * @param *buffer The string to parse.
 * @param length The length of the string to parse.
 * @param count Integer flag specifying whether or not to count lines. If yes,
 *   uses the Ragel machine optimized for counting. Otherwise uses the Ragel
 *   machine optimized for returning entity positions.
 * @param *callback Callback function. If count is set, callback is called for
 *   every line of code, comment, or blank with 'lcode', 'lcomment', and
 *   'lblank' respectively. Otherwise callback is called for each entity found.
 */
void parse_java(char *buffer, int length, int count,
  void (*callback) (const char *lang, const char *entity, int start, int end)
  ) {
  init

  
#line 184 "ext/ohcount_native/ragel_parsers/java.h"
	{
	cs = java_start;
	ts = 0;
	te = 0;
	act = 0;
	}
#line 109 "ext/ohcount_native/ragel_parsers/java.rl"
  cs = (count) ? java_en_java_line : java_en_java_entity;
  
#line 194 "ext/ohcount_native/ragel_parsers/java.h"
	{
	int _klen;
	unsigned int _trans;
	short _widec;
	const char *_acts;
	unsigned int _nacts;
	const short *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_acts = _java_actions + _java_from_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 10:
#line 1 "ext/ohcount_native/ragel_parsers/java.rl"
	{ts = p;}
	break;
#line 216 "ext/ohcount_native/ragel_parsers/java.h"
		}
	}

	_widec = (*p);
	_klen = _java_cond_lengths[cs];
	_keys = _java_cond_keys + (_java_cond_offsets[cs]*2);
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				switch ( _java_cond_spaces[_java_cond_offsets[cs] + ((_mid - _keys)>>1)] ) {
	case 0: {
		_widec = (short)(128 + ((*p) - -128));
		if ( 
#line 9 "ext/ohcount_native/ragel_parsers/java.rl"
 p+1 < pe && *(p+1) != '\n'  ) _widec += 256;
		break;
	}
				}
				break;
			}
		}
	}

	_keys = _java_trans_keys + _java_key_offsets[cs];
	_trans = _java_index_offsets[cs];

	_klen = _java_single_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( _widec < *_mid )
				_upper = _mid - 1;
			else if ( _widec > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _java_range_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _java_indicies[_trans];
_eof_trans:
	cs = _java_trans_targs[_trans];

	if ( _java_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _java_actions + _java_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 53 "ext/ohcount_native/ragel_parsers/java.rl"
	{
  if (!line_contains_code && !line_start) line_start = ts;
  line_contains_code = 1;
}
	break;
	case 1:
#line 58 "ext/ohcount_native/ragel_parsers/java.rl"
	{
  if (!line_contains_code) {
    whole_line_comment = 1;
    if (!line_start) line_start = ts;
  }
}
	break;
	case 2:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }
	break;
	case 3:
#line 52 "ext/ohcount_native/ragel_parsers/java.rl"
	{ entity = INTERNAL_NL; }
	break;
	case 4:
#line 65 "ext/ohcount_native/ragel_parsers/java.rl"
	{ entity = JAVA_SPACE; }
	break;
	case 5:
#line 68 "ext/ohcount_native/ragel_parsers/java.rl"
	{ entity = NEWLINE;    }
	break;
	case 6:
#line 69 "ext/ohcount_native/ragel_parsers/java.rl"
	{ entity = JAVA_ANY;   }
	break;
	case 7:
#line 83 "ext/ohcount_native/ragel_parsers/java.rl"
	{ entity = JAVA_SPACE;   }
	break;
	case 8:
#line 84 "ext/ohcount_native/ragel_parsers/java.rl"
	{ entity = JAVA_COMMENT; }
	break;
	case 11:
#line 1 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;}
	break;
	case 12:
#line 66 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;}
	break;
	case 13:
#line 67 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;}
	break;
	case 14:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }}
	break;
	case 15:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }}
	break;
	case 16:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }}
	break;
	case 17:
#line 66 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;}
	break;
	case 18:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }}
	break;
	case 19:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }}
	break;
	case 20:
#line 33 "ext/ohcount_native/ragel_parsers/java.rl"
	{{p = ((te))-1;}{
    switch(entity) {
    case JAVA_SPACE:
      ls
      break;
    case JAVA_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(JAVA_LANG)
      break;
    case NEWLINE:
      std_newline(JAVA_LANG)
    }
  }}
	break;
	case 21:
#line 74 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;{
    callback(JAVA_LANG, java_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 22:
#line 86 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p+1;}
	break;
	case 23:
#line 74 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;{
    callback(JAVA_LANG, java_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 24:
#line 74 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;{
    callback(JAVA_LANG, java_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 25:
#line 86 "ext/ohcount_native/ragel_parsers/java.rl"
	{te = p;p--;}
	break;
	case 26:
#line 86 "ext/ohcount_native/ragel_parsers/java.rl"
	{{p = ((te))-1;}}
	break;
#line 525 "ext/ohcount_native/ragel_parsers/java.h"
		}
	}

_again:
	_acts = _java_actions + _java_to_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 9:
#line 1 "ext/ohcount_native/ragel_parsers/java.rl"
	{ts = 0;}
	break;
#line 538 "ext/ohcount_native/ragel_parsers/java.h"
		}
	}

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	if ( _java_eof_trans[cs] > 0 ) {
		_trans = _java_eof_trans[cs] - 1;
		goto _eof_trans;
	}
	}

	_out: {}
	}
#line 111 "ext/ohcount_native/ragel_parsers/java.rl"

  // if no newline at EOF; callback contents of last line
  if (count) { process_last_line(JAVA_LANG) }
}

#endif

/*****************************************************************************/
